float celshade(sampler2D depth,float poslength){
float pw = 1.0/1280.0;
float ph = pw*aspectRatio;

float outline = ld(texture2D(depth,texcoord.xy).r)*far*8.0;
outline-= ld(texture2D(depth,texcoord.xy+vec2(pw*2.0,0.0)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(-pw*2.0,0.0)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(0.0,ph*2.0)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(0.0,-ph*2.0)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(pw*1.4,ph*1.4)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(-pw*1.4,ph*1.4)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(pw*1.4,-ph*1.4)).r)*far;
outline-= ld(texture2D(depth,texcoord.xy+vec2(-pw*1.4,-ph*1.4)).r)*far;

//outline = -outline;

outline = mix(clamp(1.0-outline*0.5,0.0,1.0),1.0,clamp(poslength/512,0.0,1.0));

return outline;
}